#!/bin/bash
#
# /usr/sbin/internmetdaemon.sh
#
# Version 1.0 - 20.6.2024
#
#

template_user=linuxadmin
servername=server
#
# folgende Option muss ggf. der eigenen AD-Domain angepasst werden
ad_domain=lmn.lan

user=$(who | awk '$2 ~ /:0/ {print $1}')
krbfile=$(find /tmp -user "$user" -name "krb5cc*" -type f)
#
# folgende Optionen fuer ldbsearch Version 4.7.6 - Ubuntu 18.04
# i_member=$(ldbsearch -k yes --krb5-ccache=$krbfile -H ldaps://$servername.$ad_domain "(&(samaccountname=$user))" | grep -E "memberOf.*CN=internet")
#
# folgende Optionen fuer ldbsearch Version 4.15.13 - Ubuntu 22.04
i_member=$(sudo -u $user ldbsearch --use-kerberos=required --use-krb5-ccache=$krbfile -H ldap://$servername.$ad_domain "(&(samaccountname=$user))" | grep -E "memberOf.*CN=internet")

if [[ -z "$i_member" ]]  && [[ -n "$user" ]] && [[ $user != $template_user ]]
then
iptables -A OUTPUT -p tcp --dport 3128 -j REJECT
# echo $(date)" ... Internet aus für "$user >> /var/log/i_on_off.log
else
iptables -D OUTPUT -p tcp --dport 3128 -j REJECT
# echo $(date)" ... Internet an für "$user >> /var/log/i_on_off.log
fi 

exit 0
